function EraPerformance1 = MFSMP_E1(testcase,AllPerformances,p)
%ERA 1:
    %EPOCH 0 2020-2023 - No changes
    %EPOCH 2 2023-2032 - Double interest in fish welfare
    %EPOCH 4 2032-2045 - Lower mortality and damage rates for well-boat transport
tStart_era1 = tic;
[largestfleet,NumFleets,Ves] = getFleets(testcase);
obj = inf;
Attribute = xlsread('ReadAttributes.xlsx');
for i = 1:size(Attribute,2)/6
    tstart_e1e1 = tic
    fleetsim_start = i
if find(isnan(Attribute(:,6*i-5:6*i)),1) > 0
    A = Attribute(:,6*i-5:6*i);
    B = find(isnan(A),1)-1;
    Attributes = A(1:B,:)
else
    Attributes = Attribute(:,6*i-5:6*i)
end

if testcase == 1
    FishFarms = xlsread('FishFarms.xlsx');
elseif testcase == 2
    FishFarms = xlsread('FishFarms2.xlsx');
elseif testcase == 3
    FishFarms = xlsread('FishFarms3.xlsx');
else
    error('Invalid case number')
end

assignin('base','FishFarms',FishFarms)
NumFarms = size(FishFarms,1);
assignin('base','NumFarms',NumFarms)
NumRoutes = NumFarms * 4;
assignin('base','NumRoutes',NumRoutes)

MissionLists = getMissions(NumRoutes,largestfleet,NumFarms,testcase,Ves);
if find(isnan(MissionLists(:,NumRoutes*(i-1)+1:NumRoutes*i)),1) > 0
    C = MissionLists(:,NumRoutes*(i-1)+1:NumRoutes*i);
    D = find(isnan(C),1)-1;
    MissionList = C(1:D,:)
else
    MissionList = MissionLists(:,NumRoutes*(i-1)+1:NumRoutes*i)
end 

assignin('base','MissionList',MissionList)

%VesselLink = ones(size(Attributes,1),size(FishFarms,1));
NumShips = size(Attributes,1);
assignin('base','Attributes',Attributes)
assignin('base','NumShips',NumShips)

EraPerformance = zeros(3,size(AllPerformances,2));
AnnualPerformance = AllPerformances/1.5;
n = 3; %3 years period for this epoch
r = ((1+p)^n-1)/(p*(1+p)^n);
PeriodPerformance = AnnualPerformance * r;
EraPerformance(1,:) = PeriodPerformance; % 3 years


if testcase == 1
    [z] = sim('MFSMP_Sim_E2'); %Fish Welfare importance has doubled
elseif testcase == 2
    [z] = sim('MFSMP_Sim2_E2');
elseif testcase == 3
    [z] = sim('MFSMP_Sim3_E2');
else
    error('Invalid case number')
end

%Takes the last value of the logged data as the final backlog value
backlog = z.yout{1}.Values.Data(end);
performance_E2 = z.simout.Data(:,:,end)
PerformancesE2(i) = performance_E2(1,1);
tEnd_E1E1 = toc(tstart_e1e1);
end

for i = 1:size(Attribute,2)/6
    tstart_e1e3 = tic
    fleetsim_start_E4 = i
if testcase == 1
    [z] = sim('MFSMP_Sim_E4'); %Well-boat technology enhanced
elseif testcase == 2
    [z] = sim('MFSMP_Sim2_E4');
elseif testcase == 3
    [z] = sim('MFSMP_Sim3_E4');
else
    error('Invalid case number')
end

backlog = z.yout{1}.Values.Data(end);
performance_E4 = z.simout.Data(:,:,end)
PerformancesE4(i) = performance_E4(1,1);
tEnd_E1E3 = toc(tstart_e1e3);
end

AnnualPerformancE2 = PerformancesE2/1.5;
n1 = 3;  %Epoch starts after 3 years
n2 = 12; %Epoch ends 12 years after present day
r1 = ((1+p)^n1-1)/(p*(1+p)^n1);
r2 = ((1+p)^n2-1)/(p*(1+p)^n2);
PeriodPerformancE2 = AnnualPerformancE2 * (r2-r1);

EraPerformance(2,:) = PeriodPerformancE2;


AnnualPerformancE4 = PerformancesE4/1.5;
n1 = 12;  %Epoch starts after 3 years
n2 = 25; %Epoch ends 12 years after present day
r1 = ((1+p)^n1-1)/(p*(1+p)^n1);
r2 = ((1+p)^n2-1)/(p*(1+p)^n2);
PeriodPerformancE4 = AnnualPerformancE4 * (r2-r1);

EraPerformance(3,:) = PeriodPerformancE4;

writematrix(EraPerformance,'PerformanceReportEra1.xlsx')
tEnd_Era1 = toc(tStart_era1)

EraPerformance1 = sum(EraPerformance);

end