function EraPerformance = MFSMP_E2(testcase,AllPerformances,p)
%ERA 2:
    %EPOCH 6 2020-2023 - 20% decrease in demand
    %EPOCH 1 2023-2030 - 20% of fish farms move offshore
    %EPOCH 3 2030-2045 - Emissions double in importance
tStart_era2 = tic;
[largestfleet,NumFleets,Ves] = getFleets(testcase);
obj = inf;
Attribute = xlsread('ReadAttributes.xlsx');
for i = 1:size(Attribute,2)/6
    tstart_e2e1 = tic
    fleetsim_start = i
if find(isnan(Attribute(:,6*i-5:6*i)),1) > 0
    A = Attribute(:,6*i-5:6*i);
    B = find(isnan(A),1)-1;
    Attributes = A(1:B,:)
else
    Attributes = Attribute(:,6*i-5:6*i)
end

if testcase == 1
    FishFarms = xlsread('FishFarms_E6.xlsx');
elseif testcase == 2
    FishFarms = xlsread('FishFarms2_E6.xlsx');
elseif testcase == 3
    FishFarms = xlsread('FishFarms3_E6.xlsx');
else
    error('Invalid case number')
end

assignin('base','FishFarms',FishFarms)
NumFarms = size(FishFarms,1);
assignin('base','NumFarms',NumFarms)
NumRoutes = NumFarms * 4;
assignin('base','NumRoutes',NumRoutes)

MissionLists = getMissions(NumRoutes,largestfleet,NumFarms,testcase,Ves);
if find(isnan(MissionLists(:,NumRoutes*(i-1)+1:NumRoutes*i)),1) > 0
    C = MissionLists(:,NumRoutes*(i-1)+1:NumRoutes*i);
    D = find(isnan(C),1)-1;
    MissionList = C(1:D,:)
else
    MissionList = MissionLists(:,NumRoutes*(i-1)+1:NumRoutes*i)
end 

assignin('base','MissionList',MissionList)

NumShips = size(Attributes,1);
assignin('base','Attributes',Attributes)
assignin('base','NumShips',NumShips)

if testcase == 1
    [z] = sim('MFSMP_Sim'); %Demand decrease by 20%
elseif testcase == 2
    [z] = sim('MFSMP_Sim2');
elseif testcase == 3
    [z] = sim('MFSMP_Sim3');
else
    error('Invalid case number')
end

backlog = z.yout{1}.Values.Data(end);
performance_E6 = z.simout.Data(:,:,end)
PerformancesE6(i) = performance_E6(1,1);
tEnd_E2E1 = toc(tstart_e2e1);
end
EraPerformance2 = zeros(3,size(AllPerformances,2));
AnnualPerformance_E6 = PerformancesE6/1.5;
n = 3; %3 years period for this epoch
r = ((1+p)^n-1)/(p*(1+p)^n);
PeriodPerformance = AnnualPerformance_E6 * r;
EraPerformance2(1,:) = PeriodPerformance;

for i = 1:size(Attribute,2)/6
    tstart_e2e2 = tic
    fleetsim_start_E1 = i
    
%20% largest fish farms move offshore: size x1.5, sailing distance = 100nm
if testcase == 1
    FishFarms = xlsread('FishFarms_E1.xlsx'); 
elseif testcase == 2
    FishFarms = xlsread('FishFarms2_E1.xlsx');
elseif testcase == 3
    FishFarms = xlsread('FishFarms3_E1.xlsx');
else
    error('Invalid case number')
end

assignin('base','FishFarms',FishFarms)
NumFarms = size(FishFarms,1);
assignin('base','NumFarms',NumFarms)
NumRoutes = NumFarms * 4;
assignin('base','NumRoutes',NumRoutes)
    
if testcase == 1
    [z] = sim('MFSMP_Sim'); 
elseif testcase == 2
    [z] = sim('MFSMP_Sim2');
elseif testcase == 3
    [z] = sim('MFSMP_Sim3');
else
    error('Invalid case number')
end

backlog = z.yout{1}.Values.Data(end);
performance_E1 = z.simout.Data(:,:,end)
PerformancesE1(i) = performance_E1(1,1);
tEnd_E2E2 = toc(tstart_e2e2);
end
AnnualPerformancE1 = PerformancesE1/1.5;
n1 = 3;  %Epoch starts after 3 years
n2 = 10; %Epoch ends 10 years after present day
r1 = ((1+p)^n1-1)/(p*(1+p)^n1);
r2 = ((1+p)^n2-1)/(p*(1+p)^n2);
PeriodPerformance2 = AnnualPerformancE1 * (r2-r1);

EraPerformance2(2,:) = PeriodPerformance2;


for i = 1:size(Attribute,2)/6
    tstart_e2e3 = tic
    fleetsim_start_E3 = i
if testcase == 1
    [z] = sim('MFSMP_Sim_E3'); %Emissions importance doubled
elseif testcase == 2
    [z] = sim('MFSMP_Sim2_E3');
elseif testcase == 3
    [z] = sim('MFSMP_Sim3_E3');
else
    error('Invalid case number')
end

backlog = z.yout{1}.Values.Data(end);
performance_E3 = z.simout.Data(:,:,end)
PerformancesE3(i) = performance_E3(1,1);
tEnd_E2E3 = toc(tstart_e2e3);
end

AnnualPerformanceE3 = PerformancesE3/1.5;
n1 = 10; %Epoch starts after 10 years
n2 = 25; %Epoch ends 25 years after present day
r1 = ((1+p)^n1-1)/(p*(1+p)^n1);
r2 = ((1+p)^n2-1)/(p*(1+p)^n2);
PeriodPerformanceE3 = AnnualPerformanceE3 * (r2-r1);

EraPerformance2(3,:) = PeriodPerformanceE3;

writematrix(EraPerformance2,'PerformanceReportEra2.xlsx')
tEnd_Era2 = toc(tStart_era2);

EraPerformance = sum(EraPerformance2);

end