function EraPerformance3 = MFSMP_E3(testcase,AllPerformances,p)
%ERA 3:
    %EPOCH 5 2020-2030 - 20% increase in demand
    %EPOCH 7 2030-2035 - 20% increase in demand + Double interest in fish welfare
    %EPOCH 8 2035-2045 - 20% increase in demand + Double interest in fish welfare + Lower mortality 
tStart_era3 = tic;
[largestfleet,NumFleets,Ves] = getFleets(testcase);
obj = inf;
Attribute = xlsread('ReadAttributes.xlsx');
for i = 1:size(Attribute,2)/6
    tStart_e3e1 = tic
    fleetsim_start = i
if find(isnan(Attribute(:,6*i-5:6*i)),1) > 0
    A = Attribute(:,6*i-5:6*i);
    B = find(isnan(A),1)-1;
    Attributes = A(1:B,:)
else
    Attributes = Attribute(:,6*i-5:6*i)
end

%The increased demand is maintained throughout the entire era
if testcase == 1
    FishFarms = xlsread('FishFarms_E5.xlsx'); 
elseif testcase == 2
    FishFarms = xlsread('FishFarms2_E5.xlsx');
elseif testcase == 3
    FishFarms = xlsread('FishFarms3_E5.xlsx');
else
    error('Invalid case number')
end

assignin('base','FishFarms',FishFarms)
NumFarms = size(FishFarms,1);
assignin('base','NumFarms',NumFarms)
NumRoutes = NumFarms * 4;
assignin('base','NumRoutes',NumRoutes)

MissionLists = getMissions(NumRoutes,largestfleet,NumFarms,testcase,Ves);
if find(isnan(MissionLists(:,NumRoutes*(i-1)+1:NumRoutes*i)),1) > 0
    C = MissionLists(:,NumRoutes*(i-1)+1:NumRoutes*i);
    D = find(isnan(C),1)-1;
    MissionList = C(1:D,:)
else
    MissionList = MissionLists(:,NumRoutes*(i-1)+1:NumRoutes*i)
end 

assignin('base','MissionList',MissionList)

NumShips = size(Attributes,1);
assignin('base','Attributes',Attributes)
assignin('base','NumShips',NumShips)

if testcase == 1
    [z] = sim('MFSMP_Sim'); 
elseif testcase == 2
    [z] = sim('MFSMP_Sim2');
elseif testcase == 3
    [z] = sim('MFSMP_Sim3');
else
    error('Invalid case number')
end

backlog = z.yout{1}.Values.Data(end);
performance_E5 = z.simout.Data(:,:,end)
PerformancesE5(i) = performance_E5(1,1);
tEnd_E3E1 = toc(tStart_e3e1);
end
EraPerformance = zeros(3,size(AllPerformances,2));
AnnualPerformance_E5 = PerformancesE5/1.5;
n = 10; 
r = ((1+p)^n-1)/(p*(1+p)^n);
PeriodPerformance = AnnualPerformance_E5 * r;
EraPerformance(1,:) = PeriodPerformance;


for i = 1:size(Attribute,2)/6
    fleetsim_start_E7 = i
    tStart_e3e2 = tic
if testcase == 1
    [z] = sim('MFSMP_Sim_E3'); %Double interest in fish welfare
elseif testcase == 2
    [z] = sim('MFSMP_Sim2_E3'); 
elseif testcase == 3
    [z] = sim('MFSMP_Sim3_E3');
else
    error('Invalid case number')
end

backlog = z.yout{1}.Values.Data(end);
performance_E7 = z.simout.Data(:,:,end)
PerformancesE7(i) = performance_E7(1,1);
tEnd_E3E2 = toc(tStart_e3e2);
end
AnnualPerformance7 = PerformancesE7/1.5;
n1 = 10; 
n2 = 15;
r1 = ((1+p)^n1-1)/(p*(1+p)^n1);
r2 = ((1+p)^n2-1)/(p*(1+p)^n2);
PeriodPerformance7 = AnnualPerformance7 * (r2-r1);

EraPerformance(2,:) = PeriodPerformance7;

for i = 1:size(Attribute,2)/6
    tStart_e3e3 = tic
    fleetsim_start_E8 = i
    
if testcase == 1
    [z] = sim('MFSMP_Sim_E4'); %Lower mortality for well-boat transport
elseif testcase == 2
    [z] = sim('MFSMP_Sim2_E4');
elseif testcase == 3
    [z] = sim('MFSMP_Sim3_E4');
else
    error('Invalid case number')
end

backlog = z.yout{1}.Values.Data(end);
performance_E8 = z.simout.Data(:,:,end)
PerformancesE8(i) = performance_E8(1,1);
tEnd_E3E3 = toc(tStart_e3e3);
end

AnnualPerformance8 = PerformancesE8/1.5;
n1 = 15;  
n2 = 25; 
r1 = ((1+p)^n1-1)/(p*(1+p)^n1);
r2 = ((1+p)^n2-1)/(p*(1+p)^n2);
PeriodPerformance8 = AnnualPerformance8 * (r2-r1);

EraPerformance(3,:) = PeriodPerformance8;

writematrix(EraPerformance,'PerformanceReportEra3.xlsx')
tEnd_Era3 = toc(tStart_era3);

EraPerformance3 = sum(EraPerformance);

end