function [largestfleet,NumFleets,Ves] = getFleets(testcase)
if testcase == 1 %Reads the vessels in each fleet from Xpress results
    f = xlsread('Vessels.xlsx');
elseif testcase == 2
    f = xlsread('Vessels2.xlsx');
elseif testcase == 3
    f = xlsread('Vessels3.xlsx');
else
    error('Invalid case number')
end

%Removes all entries indicating that a vessel has NOT been chosen
i = 1;
while i <= length(f)
    if f(i,2) == 0
        f(i,:) = [];
    else
        i = i+1;
    end
end

%Derive the number of fleets and how long the entry for each fleet is
NumFleets = 1;
B = [];
for j = 2:length(f)
    if f(j,1) < f(j-1,1)
        B(NumFleets) = j;
        NumFleets = NumFleets + 1;
    end
end
B(NumFleets) = length(f)+1;

%Derives the number of different vessel types in the fleet
VesInFleet = [];
VesInFleet(1) = B(1)-1;
for i = 2:NumFleets
    VesInFleet(i) = B(i)-B(i-1);
end

%Rearrange the fleet list
g = zeros(max(VesInFleet),2*NumFleets);
g(1:B(1)-1,1:2) = f(1:B(1)-1,:);

for i = 2:length(B)
    g(1:B(i)-B(i-1),2*i-1:2*i) = f(B(i-1):B(i)-1,:);
end
for i = 1:NumFleets
    Ves(:,2*i-1:2*i) = sortrows(g(:,2*i-1:2*i),'descend');
end

%USed to change the vessel number from Xpress to actual vessel attributes
rawData = xlsread('Wellboats.xlsx');

%Derive the largest number of vessels in a fleet to create vessel list
largestfleet = sum(Ves(:,2));
for i = 2:NumFleets
    if sum(Ves(:,2*i)) > largestfleet
        largestfleet = round(sum(Ves(:,2*i)));
    end
end


%Creates list of vessels in each fleet as a large matrix
h = zeros(largestfleet,5*NumFleets);
i = 1;
for a = 1:NumFleets
    for j = 1:5 %5 different attributes.
        h(i:(i+Ves(i,2*a)-1),j+5*(a-1)) = round(rawData(j+1,Ves(i,2*a-1))); 
    end
end
for a = 1:NumFleets
    for i = 2:VesInFleet(a)
        for j = 1:5
            h(1+sum(Ves(1:(i-1),2*a)):1+sum(Ves(1:i,2*a))-1,j+5*(a-1)) = round(rawData(j+1,Ves(i,2*a-1)));
        end 
    end
end
for i = 1:size(h,1)
    for j = 1:size(h,2)
        if h(i,j) == 0
            h(i,j) = NaN;
        end
    end
end

%Writes the attributes of each vessel in each fleet to Excel file. 
writematrix(h,'ReadAttributes.xlsx')

end